/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      RTOS

  Description:  The module contents interface for RTOS.c and
                the XC16x task definitions.

  -------------------------------------------------------------------------

                $RCSfile: RtosX16x.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1 $  $Date: 2004/10/06 12:31:25 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/11/04 -as:   creating

****************************************************************************/

#ifndef _RTOSXC16X_H_
#define _RTOSXC16X_H_

// -------------------------------------------------------------------------
// const defines

// define TASKNO for XC16x
#define TASK_MAIN                        // Dummy-Bezeichner
#define TRAPNO_16              16
#define TRAPNO_17              17
#define TRAPNO_18              18
#define TRAPNO_19              19

#define TRAPNO_20              20
#define TRAPNO_21              21
#define TRAPNO_22              22
#define TRAPNO_23              23
#define TRAPNO_24              24
#define TRAPNO_25              25
#define TRAPNO_26              26
#define TRAPNO_27              27
#define TRAPNO_28              28
#define TRAPNO_29              29

#define TRAPNO_30              30
#define TRAPNO_31              31
#define TRAPNO_32              32
#define TRAPNO_33              33
#define TRAPNO_34              34
#define TRAPNO_35              35
#define TRAPNO_36              36
#define TRAPNO_37              37
#define TRAPNO_38              38
#define TRAPNO_39              39

#define TRAPNO_40              40
#define TRAPNO_41              41
#define TRAPNO_42              42
#define TRAPNO_43              43
#define TRAPNO_44              44
#define TRAPNO_45              45
#define TRAPNO_46              46
#define TRAPNO_47              47
#define TRAPNO_48              48
#define TRAPNO_49              49

#define TRAPNO_50              50
#define TRAPNO_51              51
#define TRAPNO_52              52
#define TRAPNO_53              53
#define TRAPNO_54              54
#define TRAPNO_55              55
#define TRAPNO_56              56
#define TRAPNO_57              57
#define TRAPNO_58              58
#define TRAPNO_59              59

#define TRAPNO_60              60
#define TRAPNO_61              61
#define TRAPNO_62              62
#define TRAPNO_63              63
#define TRAPNO_64              64
#define TRAPNO_65              65
#define TRAPNO_66              66
#define TRAPNO_67              67
#define TRAPNO_68              68
#define TRAPNO_69              69

#define TRAPNO_70              70
#define TRAPNO_71              71
#define TRAPNO_72              72
#define TRAPNO_73              73
#define TRAPNO_74              74
#define TRAPNO_75              75
#define TRAPNO_76              76
#define TRAPNO_77              77
#define TRAPNO_78              78
#define TRAPNO_79              79

#define TRAPNO_80              80
#define TRAPNO_81              81
#define TRAPNO_82              82
#define TRAPNO_83              83
#define TRAPNO_84              84
#define TRAPNO_85              85
#define TRAPNO_86              86
#define TRAPNO_87              87
#define TRAPNO_88              88
#define TRAPNO_89              89

#define TRAPNO_90              90
#define TRAPNO_91              91
#define TRAPNO_92              92
#define TRAPNO_93              93
#define TRAPNO_94              94
#define TRAPNO_95              95

// define TASKNO only for XC161
// ...

// -------------------------------------------------------------------------
#define OS_TASK                 interrupt

#define CALL_FROM_INTERRUPT     // Kennzeichnen von ISR-Funktionen 

// -------------------------------------------------------------------------
// Definition des ShutDown-Levels
#define RTOS_SHUTDOWN_SYS_LEVEL  0x00    // smtlich Handler deinstalliieren
#define RTOS_SHUTDOWN_USER_LEVEL 0x01    // User-Handler deinstallieren

// -------------------------------------------------------------------------
// types

#define kRtosSuccessful         0x00
#define kRtosFatalError         0xFF
#define kRtosUnvalidTaskNo      0x80
#define kRtosUnvalidTaskHandler 0x81

//-------------------------------------------------------------------------

typedef void (PUBLIC ROM* tfpRtosTaskHandler)     (void);

//-------------------------------------------------------------------------
// prototypes for LZS internal usage

void     PUBLIC RtosInit            (void);
BYTE     PUBLIC RtosShutDown        (BYTE bShutDownMode_p);

BYTE     PUBLIC RtosCreateTask      (BYTE bTaskNo_p, 
                                     tfpRtosTaskHandler fpTaskHandler_p);
BYTE     PUBLIC RtosDeleteTask      (BYTE bTaskNo_p);
BYTE     PUBLIC RtosDelayTask       (BYTE bTaskNo_p, DWORD dwTimeout_p);
BYTE     PUBLIC RtosSendSignal      (BYTE bTaskNo_p);
BYTE     PUBLIC RtosClearSignal     (BYTE bTaskNo_p);
BYTE     PUBLIC RtosDisableTask     (BYTE bTaskNo_p);
BYTE     PUBLIC RtosEnableTask      (BYTE bTaskNo_p);

//-------------------------------------------------------------------------
#endif
