/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      COMBImodul-C14

  Description:  The module contents interface for RTOS.c and
                the target specific task numbers.

  -------------------------------------------------------------------------

                $RCSfile: rtos.h,v $
                
                $Author: A.Suess $
                
                $Revision: 1.6 $  $Date: 2004/10/28 13:00:59 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

  2003/11/04 -as:   creating

****************************************************************************/

#ifndef _RTOS_H_
#define _RTOS_H_
//-------------------------------------------------------------------------
#include "rtos/rtosX16x.h"

//-------------------------------------------------------------------------
// const defines
// define TASKNO for application

// task for creating software watchdog
#define TASK_TMR_WDT            TRAPNO_18     // TRAPNO CC2
#define ILVL_TASK_TMR_WDT       15
#define GLVL_TASK_TMR_WDT       3
#define XGLVL_TASK_TMR_WDT      1

// task to signal PLL errors
#define TASK_PLL_ERROR          TRAPNO_67     // TRAPNO PLL
#define ILVL_TASK_PLL           15
#define GLVL_TASK_PLL           3

// task to signal adc overrun errors
#define TASK_ADC_ERROR          TRAPNO_41     // TRAPNO ADC Overrun Error
#define ILVL_TASK_ADCE          15
#define GLVL_TASK_ADCE          2

// task to cycle call of CANopen process
#define TASK_TMR_COM            TRAPNO_19     // TRAPNO CC3
#define ILVL_TASK_COP           2
#define GLVL_TASK_COP           0

//#define TASK_SYS_TIME           TRAPNO_58     // TRAPNO CC26
//#define TASK_ASC1_ERROR         TRAPNO_74     // TRAPNO ASC1 Error
//#define TASK_SSC0_ERROR         TRAPNO_47     // TRAPNO SSC0 Error
//#define TASK_EEPROM             TRAPNO_16     // TRAPNO CC0
//#define TASK_TX_HANDLER_XUART1  TRAPNO_17     // TRAPNO CC1
//#define TASK_TX_HANDLER_XUART2  TRAPNO_18     // TRAPNO CC2
//#define TASK_POWER_FAIL         TRAPNO_24     // TRAPNO CC8
//#define TASK_BATT_FAIL          TRAPNO_25     // TRAPNO CC9
//#define TASK_CARD_DETECT1       TRAPNO_30     // TRAPNO CC14
//#define TASK_CARD_DETECT2       TRAPNO_31     // TRAPNO CC15
//#define TASK_INT_ETH            TRAPNO_48     // TRAPNO CC16
//#define TASK_INT_XUART1         TRAPNO_49     // TRAPNO CC17
//#define TASK_INT_XUART2         TRAPNO_50     // TRAPNO CC18
//#define TASK_RTC_ALARM          TRAPNO_51     // TRAPNO CC19
//#define TASK_RTC                TRAPNO_35     // TRAPNO T2
#define TASK_ADC_COMPLETE       TRAPNO_40     // TRAPNO ADC
//#define TASK_ASC0_TX_CHAR       TRAPNO_42     // TRAPNO ASC0 Transmit
//#define TASK_ASC0_RECEIVE       TRAPNO_43     // TRAPNO ASC0 Receive
//#define TASK_ASC0_ERROR         TRAPNO_44     // TRAPNO ASC0 Error
//#define TASK_ASC1_TX_CHAR       TRAPNO_72     // TRAPNO ASC1 Transmit
//#define TASK_ASC1_RECEIVE       TRAPNO_73     // TRAPNO ASC1 Receive
#define TASK_COMMPRO            TASK_TMR_COM     // TRAPNO CC25

//#define TASK_CAN0_INSTANCE_1    TRAPNO_84     // TRAPNO CAN0
//#define TASK_CAN1_INSTANCE_1    TRAPNO_85     // TRAPNO CAN1
//#define TASK_CAN2_INSTANCE_1    TRAPNO_86     // TRAPNO CAN2
//#define TASK_CAN3_INSTANCE_1    TRAPNO_87     // TRAPNO CAN3

//#define TASK_CAN0_INSTANCE_2    TRAPNO_89     // TRAPNO CAN4
//#define TASK_CAN1_INSTANCE_2    TRAPNO_90     // TRAPNO CAN5
//#define TASK_CAN2_INSTANCE_2    TRAPNO_91     // TRAPNO CAN6
//#define TASK_CAN3_INSTANCE_2    TRAPNO_92     // TRAPNO CAN7

//-------------------------------------------------------------------------
// prototypes for LZS usage (target specific)

void PUBLIC RtosInitWatchdog      (tfpRtosTaskHandler fpTaskHandler_p);
void PUBLIC RtosShutDownWatchdog  (void);
void PUBLIC RtosResetWatchdog     (void);
void PUBLIC RtosClearWatchdogEvent(void);


//-------------------------------------------------------------------------

#endif
