/****************************************************************************

  (c) SYSTEC electronic GmbH, D-07973 Greiz, August-Bebel-Str. 29
      www.systec-electronic.de

  Project:      PLCmodule C14

  Description:  Demoprogramm for the system timer driver

  -------------------------------------------------------------------------

                $RCSfile: TimrDemo.c,v $
                
                $Author: A.Suess $
                
                $Revision: 1.1.1.1 $  $Date: 2004/09/16 11:56:05 $
                
                $State: Exp $
                
                Build Environment:
                KEIL uVision 2

  -------------------------------------------------------------------------

  Revision History:

   2003/10/27 -ct:   start of the implementation version 1.0

****************************************************************************/

#include <xc161.h>
#include "generic/global.h"
#include "../include/timerdrv.h"



/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*          G L O B A L   D E F I N I T I O N S                            */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

//---------------------------------------------------------------------------
// const defines
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// local types
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// modul globale vars
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// local function prototypes
//---------------------------------------------------------------------------




/***************************************************************************/
/*                                                                         */
/*                                                                         */
/*          C L A S S  <main>                                              */
/*                                                                         */
/*                                                                         */
/***************************************************************************/
//
// Description: 
//
//              This main programm test all the function of the system timer
//              T8.
//
/***************************************************************************/

void  main (void)
{
unsigned long  ulLastTime;

    // check for initialized ASC0
    if(ASC0_CON == 0)
    {
        //  Configuration of the ASC0 Baudrate Generator:
        //  - fractional divider as prescaler for baud rate timer is used
        ASC0_FDV       =  0x01D0;     // load ASC0 fractional divider register
                                      //  - required baud rate = 38,400 kbaud
                                      //  - real baud rate     = 38,400 kbaud
                                      //  - deviation          = 0,001 %
    
        ASC0_BG        =  0x003A;     // load ASC0 baud rate time reload register
    
    
        //  Configuration of the ASC0 Operation Mode:
        //  - 8-bit data asychronous operation with one stop bit
        //  - receiver is enabled
        //  - fractional divider is enabled
        ASC0_CON       =  0x0811;     // load ASC0 control register
    
        //  FIFO Configuration:
        //  - receive FIFO is disabled
        //  - transmit FIFO is disabled
        ASC0_RXFCON    =  0x0102;     // load ASC0 receive FIFO control register
        ASC0_TXFCON    =  0x0102;     // load ASC0 transmit FIFO control register
    
        //  Configuration of the used ASC0 Port Pins:
        //  - P3.10 is used for ASC Transmit Data Output (TxDA0)
        //  - P3.11 is used for ASC0 Receive data Input (RxDA0)
        ALTSEL0P3     |=  0x0400;      // select alternate output function
        P3   = (P3   & ~(WORD)0x0400) | 0x0400;    //set data register
        DP3  = (DP3  & ~(WORD)0x0400) | 0x0400;    //set direction register
    
        //  Configuration of the used ASC0 Interrupts:
        ASC0_TIC |= 0x00080;
    
        ASC0_CON      |=  0x8000;      // enable baud rate generator
    }

    StartTimer();

    PSW_IEN = 1;

    ulLastTime = GetTickCount();
    while (1)
    { 
        if ((GetTickCount() - ulLastTime) >= 1000)
        {
            ulLastTime = GetTickCount();
            printf ("\nSysTime = %05u ms", (unsigned int)GetTickCount() );
        }
    }

}














// EOF

